import mongoose from 'mongoose'
const ObjectId = mongoose.Schema.Types.ObjectId

export const notification = {
  recipients: [{
    type: ObjectId,
    ref: 'User',
  }],
  isGlobal: Boolean,
  isUniversal: Boolean,
  acknowledgedBy: [{
    type: ObjectId,
    ref: 'User',
  }],
  expirationDate: {
    type: Date,
  },
  duration: Number,
  createdAt: {
    type: Date,
    default: Date.now,
  },
  title: String,
  translateTitle: Boolean,
  type: {
    type: String,
    enum: ['announcement', 'introduction', 'error', 'messages-sent'],
  },
  group: String,
  link: {
    exists: Boolean,
    label: String,
    linkType: {
      type: String,
      enum: ['external', 'introduction', 'introduction-candidate'],
    },
    linkData: Object,
  },
  translateBody: Boolean,
  text: String,
  isDeleted: Boolean,
  acute: Boolean,
  variables: Object,
  customerId: {
    type: String,
    index: true,
  },
}