// tslint:disable array-type
export interface NotificationBase<IDType, DateType, Defaultable> {
  _id: IDType
  recipients: Array<IDType>
  isGlobal: boolean
  isUniversal: boolean
  acknowledgedBy: Array<IDType>
  expirationDate?: DateType
  duration: number
  createdAt: DateType | Defaultable
  title: string
  translateTitle: boolean
  type: 'announcement' | 'introduction' | 'error' | 'messages-sent'
  group: string
  link: {
    exists: boolean
    label: string
    linkType: 'external' | 'introduction' | 'introduction-candidate'
    linkData: any
  }
  translateBody: boolean
  text: string
  isDeleted: boolean
  acute: boolean
  variables: any
  customerId: string
}