import fs from 'fs'
import notificationSchema from './schemas/r2-notification'
import personSchema from './schemas/r2-person'
import commissionSchema from './schemas/r2-commission'
import companySchema from './schemas/r2-company'
import customerSchema from './schemas/r2-customer'
import messageSchema from './schemas/r2-message'
import userSchema from './schemas/r2-user'
import userStatusSchema from './schemas/r2-user-status'
import applicationFormSchema from './schemas/r2-applicationform'
import backgroundUpdateQueueEntrySchema from './schemas/r2-background-update-queue'
import contactPersonSchema from './schemas/r2-contactperson'
import jobPostingSchema from './schemas/r2-job-posting'
import {R2Author} from './schemas/r2-common'
import Complex from './complex'
import {Schema} from './schema'
import toTypescriptSchema from './ts-output'
import {R2Language} from './schemas/r2-language'
import {R2Contract} from './schemas/r2-contract'
import {R2Attachments} from './schemas/r2-attachment'
import authoredTextSchema from './schemas/r2-authored-text'
import {R2WorkExperience} from './schemas/r2-workexperience'
import {R2BillingInfo} from './schemas/r2-billinginfo'
import coordinatesSchema from './schemas/r2-coordinates'
import deletedProfileSchema from './schemas/r2-deleted-profile'
import languageSchema from './schemas/r2-languages'
import jessionSchema from './schemas/r2-jession'
import molProfessionSchema from './schemas/r2-molprofession'
import indexableAttachmentSchema from './schemas/r2-indexableattachment'
import integrationStatusSchema from './schemas/r2-integrationstatus'
import errorSchema from './schemas/r2-error'
import logLineSchema from './schemas/r2-logline'
import finderCitySchema from './schemas/r2-findercity'
import systemSettingsSchema from './schemas/r2-systemsettings'
import rbnInterviewSchema from './schemas/r2-rbninterview'
import rbnInviteSchema from './schemas/r2-rbninvite'
import expertiseLookupSchema from './schemas/r2-expertiselookup'
import personNameSchema from './schemas/r2-personname'
import usageAggregationSchema from './schemas/r2-usage-aggregation'
import rawRbnMessageSchema from './schemas/r2-rawrbnmessage'
import documentSchema from './schemas/r2-document'
import commissionreportSchema from './schemas/r2-commissionreport'
import {R2Comment} from './schemas/r2-comment'
import R2Interview from './schemas/r2-interview'
import {R2CandidateFilters} from './schemas/r2-filters'
import toMongooseSchema from './mongoose-output'
import {R2Education} from './schemas/r2-education'


const dir = __dirname + '/../../../misc/r2/r2-models/schemer'
fs.writeFileSync(dir + '/notification.mongoose.ts', mongoosePrefix + notificationSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/notification.ts', notificationSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/company.mongoose.ts', mongoosePrefix + companySchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/company.ts', companySchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/customer.mongoose.ts', mongoosePrefix + customerSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/customer.ts', customerSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/language.mongoose.ts', mongoosePrefix + languageSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/language.ts', languageSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/deletedprofile.mongoose.ts', mongoosePrefix + deletedProfileSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/deletedprofile.ts', deletedProfileSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/message.mongoose.ts', mongoosePrefix + messageSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/message.ts', messageSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/jobposting.mongoose.ts', mongoosePrefix + jobPostingSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/jobposting.ts', jobPostingSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/contactperson.mongoose.ts', mongoosePrefix + contactPersonSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/contactperson.ts', contactPersonSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/user.mongoose.ts', mongoosePrefix + userSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/user.ts', userSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/jession.mongoose.ts', mongoosePrefix + jessionSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/jession.ts', jessionSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/userstatus.mongoose.ts', mongoosePrefix + userStatusSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/userstatus.ts', userStatusSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/authoredtext.mongoose.ts', mongoosePrefix + authoredTextSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/authoredtext.ts', authoredTextSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/backgroundupdatequeueentry.mongoose.ts', mongoosePrefix + backgroundUpdateQueueEntrySchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/backgroundupdatequeueentry.ts', backgroundUpdateQueueEntrySchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/coordinates.mongoose.ts', mongoosePrefix + coordinatesSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/coordinates.ts', coordinatesSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/usageaggregation.mongoose.ts', mongoosePrefix + usageAggregationSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/usageaggregation.ts', usageAggregationSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/expertiselookup.mongoose.ts', mongoosePrefix + expertiseLookupSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/expertiselookup.ts', expertiseLookupSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/personname.mongoose.ts', mongoosePrefix + personNameSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/personname.ts', personNameSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/rbninterview.mongoose.ts', mongoosePrefix + rbnInterviewSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/rbninterview.ts', rbnInterviewSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/systemsettings.mongoose.ts', mongoosePrefix + systemSettingsSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/systemsettings.ts', systemSettingsSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/rbninvite.mongoose.ts', mongoosePrefix + rbnInviteSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/rbninvite.ts', rbnInviteSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/rawrbnmessage.mongoose.ts', mongoosePrefix + rawRbnMessageSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/rawrbnmessage.ts', rawRbnMessageSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/logline.mongoose.ts', mongoosePrefix + logLineSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/logline.ts', logLineSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/integrationstatus.mongoose.ts', mongoosePrefix + integrationStatusSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/integrationstatus.ts', integrationStatusSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/indexableattachment.mongoose.ts', mongoosePrefix + indexableAttachmentSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/indexableattachment.ts', indexableAttachmentSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/molprofession.mongoose.ts', mongoosePrefix + molProfessionSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/molprofession.ts', molProfessionSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/findercity.mongoose.ts', mongoosePrefix + finderCitySchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/findercity.ts', finderCitySchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/error.mongoose.ts', mongoosePrefix + errorSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/error.ts', errorSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/document.mongoose.ts', mongoosePrefix + documentSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/document.ts', documentSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/commissionreport.mongoose.ts', mongoosePrefix + commissionreportSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/commissionreport.ts', commissionreportSchema.typescript, 'UTF-8')

fs.writeFileSync(dir + '/person.mongoose.ts', mongoosePrefix + personSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/person.ts', personSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/applicationform.mongoose.ts', mongoosePrefix + applicationFormSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/applicationform.ts', applicationFormSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/commission.mongoose.ts', mongoosePrefix + commissionSchema.mongoose, 'UTF-8')
fs.writeFileSync(dir + '/commission.ts', commissionSchema.typescript, 'UTF-8')
fs.writeFileSync(dir + '/author.ts', toTypescript('Author', R2Author), 'UTF-8')
fs.writeFileSync(dir + '/languageskill.ts', toTypescript('LanguageSkill', R2Language), 'UTF-8')
fs.writeFileSync(dir + '/contract.ts', toTypescript('Contract', R2Contract), 'UTF-8')
fs.writeFileSync(dir + '/contract.mongoose.ts', toMongoose('contractMongooseSchema', R2Contract), 'UTF-8')
fs.writeFileSync(dir + '/work-experience.ts', toTypescript('WorkExperience', R2WorkExperience), 'UTF-8')
fs.writeFileSync(dir + '/billing-info.ts', toTypescript('BillingInfo', R2BillingInfo), 'UTF-8')
fs.writeFileSync(dir + '/author.ts', toTypescript('Author', R2Author), 'UTF-8')
fs.writeFileSync(dir + '/attachment.ts', toTypescript('Attachment', R2Attachments), 'UTF-8')
fs.writeFileSync(dir + '/comment.ts', toTypescript('Comment', R2Comment), 'UTF-8')
fs.writeFileSync(dir + '/comment.mongoose.ts', toMongoose('commentMongooseSchema', R2Comment), 'UTF-8')
fs.writeFileSync(dir + '/interview.ts', toTypescript('Interview', R2Interview), 'UTF-8')
fs.writeFileSync(dir + '/interview.mongoose.ts', toMongoose('interviewMongooseSchema', R2Interview), 'UTF-8')
fs.writeFileSync(dir + '/education.ts', toTypescript('Education', R2Education), 'UTF-8')
fs.writeFileSync(dir + '/education.mongoose.ts', toMongoose('educationMongooseSchema', R2Education), 'UTF-8')
fs.writeFileSync(dir + '/workexperience.ts', toTypescript('WorkExperience', R2WorkExperience), 'UTF-8')
fs.writeFileSync(dir + '/workexperience.mongoose.ts', toMongoose('workExperienceMongooseSchema', R2WorkExperience), 'UTF-8')
fs.writeFileSync(dir + '/candidate-filters.ts', toTypescript('CandidateFilters', R2CandidateFilters), 'UTF-8')

function toTypescript(name: string, obj: Complex): string {
  let schema = {
    fields: obj.subschema
  }
  return `
import mongoose from 'mongoose'
type ObjectId = mongoose.Types.ObjectId
  
${toTypescriptSchema(name, schema, 'typescript')}
  `
}

function toMongoose(name: string, obj: Complex) {
  return mongoosePrefix + toMongooseSchema(name, {fields: obj.subschema})
}
