import {Schema} from '../schema'
import ObjectId from '../object-id'
import Complex from '../complex'
import toMongooseSchema from '../mongoose-output'
import toTypescriptSchema from '../ts-output'
import toJSONSchema from '../json-schema-output'
import now from '../now'

const schema: Schema = {
  fields: {
    _jmf_domain: String,
    _jmf_last_modified: {type: Date, index: true},
    _jmf_transaction: String,
    _jmf_deleted: Boolean,
    _jmf_preserved: Object
  }
}

export default {
  get mongoose() {
    return toMongooseSchema('internalFieldsMongooseSchema', schema)
  },
  get typescript() {
    return toTypescriptSchema('InternalFields', schema, 'typescript', { omitExtraExports: true })
  },
  get json() {
    return toJSONSchema('ExampleJSONSchema', schema, false)
  }
}
