import {R2Author} from './r2-common'
import Complex from '../complex'
import ObjectId from '../object-id'

export const R2Comment = new Complex({
  _id: ObjectId,
  comment: String,
  commission: {type: ObjectId, optional: true}, // can't do this as a ref as comments can have a commission but a commission has comments, too
  author: R2Author,
  date: Date,
  industry: String,
  deleted: {type: Boolean, optional: true},
  type: { type: String, enum: ['search-show', 'search-hide', 'employable', 'not-employable', 'comment', 'suitability', 'commission-comment'] },
  rating: {type: Number, optional: true},
  edits: [{ type: ObjectId, mongooseRef: 'CommentEdit', index: false}],
  editClone: {type: new Complex({
    exists: {type: Boolean, index: true},
    comment: String,
    author: R2Author,
    date: Date
  }), optional: true}
})
