import {Schema} from '../schema'
import ObjectId from '../object-id'
import Complex from '../complex'
import toMongooseSchema from '../mongoose-output'
import toTypescriptSchema from '../ts-output'
import toJSONSchema from '../json-schema-output'
import now from '../now'
import {R2Author} from './r2-common'

const schema: Schema = {
  fields: {
    _id: ObjectId,
    person: { type: ObjectId },
    income: Number,
    status: String,
    notes: String,
    invoiceDate: { type: Date },
    invoiced: { type: Boolean, mongooseDefault: false },
    customerId: {type: String, index: true}
  }
}

export default {
  get mongoose() {
    return toMongooseSchema('commissionReportMongooseSchema', schema)
  },
  get typescript() {
    return toTypescriptSchema('CommissionReport', schema, 'typescript', { omitExtraExports: true })
  },
  get json() {
    return toJSONSchema('ExampleJSONSchema', schema, false)
  }
}
