import Complex from '../complex'
import ObjectId from '../object-id'

export const R2Author = new Complex({
  name: new Complex({
    first: String,
    last: String
  }),
  finderId: {type: Number, optional: true},
  user: {type: ObjectId, mongooseRef: 'User', optional: true, index: false}
})

export const R2Address = new Complex({
  street: {type: String, optional: true},
  zip: {type: String, optional: true},
  town: {type: String, optional: true},
  country: {type: String, optional: true}
})

export const R2IntroductionComment = new Complex({
  _id: ObjectId,
  author: new Complex({
    name: {optional: true, type: new Complex({
      last: String,
      first: String
    })},
    email: String,
    jelppId: String
  }),
  comment: String,
  createdAt: Date,
  decision: {type: String, enum: ['none', 'accept', 'process', 'reject'], mongooseDefault: 'none'}
})
