import {Schema} from '../schema'
import ObjectId from '../object-id'
import Complex from '../complex'
import toMongooseSchema from '../mongoose-output'
import toTypescriptSchema from '../ts-output'
import toJSONSchema from '../json-schema-output'
import now from '../now'

const schema: Schema = {
  fields: {
    _id: ObjectId,
    latitude: Number,
    longtitude: Number,
    placeName: String,
    lowercasePlaceName: String,
    foundUsing: String
  }
}

export default {
  get mongoose() {
    return toMongooseSchema('coordinatesMongoSchema', schema)
  },
  get typescript() {
    return toTypescriptSchema('Coordinates', schema, 'typescript', { omitExtraExports: true })
  },
  get json() {
    return toJSONSchema('ExampleJSONSchema', schema, false)
  }
}
