import {Schema} from '../schema'
import ObjectId from '../object-id'
import Complex from '../complex'
import toMongooseSchema from '../mongoose-output'
import toTypescriptSchema from '../ts-output'
import toJSONSchema from '../json-schema-output'
import now from '../now'

const schema: Schema = {
  fields: {
    _id: ObjectId,
    attachmentId: {type: ObjectId, index: true},
    personId: {type: ObjectId, index: true},
    content: String,
    failed: Boolean
  }
}

export default {
  get mongoose() {
    return toMongooseSchema('indexableAttachmentMongooseSchema', schema)
  },
  get typescript() {
    return toTypescriptSchema('IndexableAttachment', schema, 'typescript', {omitExtraExports: true})
  },
  get json() {
    return toJSONSchema('ExampleJSONSchema', schema, false)
  }
}
