import Complex from '../complex'
import {R2Author} from './r2-common'
import ObjectId from '../object-id'
import now from '../now'

export const R2Interview = new Complex({
  _id: ObjectId,
  author: R2Author,
  date: {type: Date, mongooseDefault: now},
  started: {type: Date, mongooseDefault: now},
  firstSaved: {type: Date, index: true, optional: true},
  industry: String,
  legacy: {type: Boolean, optional: true},

  edits: [
    {type: ObjectId, mongooseRef: 'InterviewEdit', index: false}
  ],
  editingStartedAt: {type: ObjectId, mongooseRef: 'InterviewEdit', index: false, optional: true},
  currentText: String,
  state: {type: String, enum: ['new', 'saved', 'editing', 'deleted', 'canceled'], mongooseDefault: 'new', index: true},
  commission: {type: ObjectId, mongooseRef: 'Commission', optional: true},
  lastModified: {type: Date, mongooseDefault: now, index: true}
})
export default R2Interview
