import {Schema} from '../schema'
import ObjectId from '../object-id'
import Complex from '../complex'
import toMongooseSchema from '../mongoose-output'
import toTypescriptSchema from '../ts-output'
import toJSONSchema from '../json-schema-output'
import now from '../now'

const schema: Schema = {
  fields: {
    _id: ObjectId,
    commissionTypeTranslations: Object,
    disableJobPostingsFromAI: Boolean,
    bassoAPIKey: String
  }
}

export default {
  get mongoose() {
    return toMongooseSchema('systemSettingsMongooseSchema', schema)
  },
  get typescript() {
    return toTypescriptSchema('SystemSettings', schema, 'typescript', { omitExtraExports: true })
  },
  get json() {
    return toJSONSchema('ExampleJSONSchema', schema, false)
  }
}
